dgit (16.7) unstable; urgency=medium

  * git-debpush: Call `git merge-base`, not `git-merge-base`.
    [Report from Simon Josefsson]  Closes: #1144142.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 11 Aug 2026 23:25:25 +0100

dgit (16.6) unstable; urgency=medium

  git-debpush:
  * New --no-pristine-tar option (for working around bugs etc).

  tag2upload development:
  * tag2upload-builder-rebuild: Avoid downgrading dgit's .debs.

  testing:
  * autopkgtest: loong64: do only minimal testing, like on riscv64.
  * Check for git options with short usage, not --help.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 09 Aug 2026 16:02:43 +0100

dgit (16.5) unstable; urgency=medium

  tag2upload development:
  * tag2upload-obtain-origs: Allow tildes in pristine-tar filenames
    Closes: #1143562.
  * tag2upload-obtain-origs: Give advice about gitattributes if
    pristine-tar fails, when applicable.  Closes: #1143511.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 04 Aug 2026 14:33:49 +0100

dgit (16.4) unstable; urgency=medium

  git-debpush:
  * git-debpush: Push refs/heads/upstream too, when appropriate
    [Report from gregor herrmann]  Closes: #1143205.
  * git-debpush(1): Improve description of pushing behaviour.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 03 Aug 2026 14:42:35 +0100

dgit (16.3) unstable; urgency=medium

  * No changes upload to restore sane version number.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 31 Jul 2026 23:56:05 +0100

dgit (16.3~) unstable; urgency=medium

  * There were no changes in this release, which was made by mistake.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 31 Jul 2026 18:33:54 +0100

dgit (16.2) unstable; urgency=medium

  tag2upload development:
  * tag2upload-obtain-origs: Fix tarballs without / in top-level dir entry
    (eg as generated by pax).  #1143196.
  * tag2upload-obtain-origs: Fix error message for tarbombs.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 31 Jul 2026 17:34:39 +0100

dgit (16.1) unstable; urgency=medium

  git-debpush:
  * git-debpush(1): New FILES and BEHAVIOUR sections;
    remove mention of no-longer-relevant --force-pristine-tar.
    [Report from gregor herrmann]  Closes: #1142508.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 31 Jul 2026 12:18:04 +0100

dgit (16.1~exp1) experimental; urgency=medium

  git-debpush:
  * Implement pristine-tar support.  Closes: #1106071.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 19 Jul 2026 11:05:39 +0100

dgit (15.14) unstable; urgency=medium

  * CI: More firmly insist on using testing, not sid
  * autopkgtests: Run only a very small handful of tests on riscv64
    to work around autopkgtest 4x perf regression.  Closes: #1142665.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 24 Jul 2026 10:48:24 +0100

dgit (15.13) unstable; urgency=medium

  tag2upload development:
  * tag2upload: Restore pristine-tar passthrough.
    [Report from Simon Josefsson]  Closes:#1142602.
  * tag2upload-obtain-origs: write "created orig(s)" instead of "orig".

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 22 Jul 2026 16:50:08 +0100

dgit (15.12) unstable; urgency=medium

  * tag2upload-obtain-origs, pristine-tar feature:
    Don't let $debuglevel be undef (avoids many harmless warnings).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 20 Jul 2026 11:26:43 +0100

dgit (15.11) unstable; urgency=medium

  git-debpush:
  * quilt mode: Ask for confirmation if changed since last upload.
  * quilt mode: If not found automatically, and not supplied, prompt for it.

  tag2upload development:
  * Builder: Support pristine-tar on the server side:
    changes to tag2upload-fetch-inputs and tag2upload-obtain-origs.
    [Code review by Andrea Pappacoda]  Progress towards #1106071.
  * tag2upload(5): Clarifications and corrections re pristine-tar.
  * git-debpush: pristine-tar detection/checking overhauled.
    (Actual support for pristine-tar is not included in this release.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 16 Jul 2026 22:25:39 +0100

dgit (15.10) unstable; urgency=medium

  Packaging:
  * Fix typo in debian/NEWS entry for 15.0 "dtails" -> "details".
    Closes: #1137237.  [Teemu Hukkanen]

  Infrastructure:
  * dgit-repos-policy-debian: Emit hints for taints in precheck.
    Closes: #1136998.  (Will be effective when deployed on push.dgit.d.o.)

  i18n:
  * nl: Update message translations.
    Closes: #1137534.  [Frans Spiesschaert]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 29 May 2026 16:55:09 +0100

dgit (15.9) unstable; urgency=medium

  git-debpush:
  * Fix `remote_objid` variable unset in some git fetch corner cases.
  * Make git fetch object cacheing as effective as intended.

  tag2upload development:
  * Improve an obscure error path, failing better if cd were to fail.
  * Use git-deborig from testing in builder image.  Will fix warnings
    about is_native from libdpkg-perl.   (Only effective after image rebuild.)

  i18n:
  * pt: Update message and manpage translations.
    Closes: #1136125, #1136129.  [Américo Monteiro]

  Testing:
  * CI: Turn up debugging from curl and perl's libcurl.
  * http-static-server: confess on bad request, to try to debug mystery 400.
  * Reorganisation to support futher tag2upload work.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 18 May 2026 19:59:46 +0100

dgit (15.8) unstable; urgency=medium

  git-debpush:
  * New --extra-metadata option for adding arbitrary metadata items.
  * Formatting improvements to the generated tag (no semantic change).
  * Better explain the risks of forcing branch-* checks (docs and messages).

  tag2upload development:
  * tag2upload(5): Contemplate multiple orig tarballs with pristine-tar.
  * tag2upload-obtain-origs: Save origs into s_bpd, not hardcocded ../bpd.
  * tag2upload-obtain-origs: Put origs.sha256sums in a tmp dir in .git.
  * dgit-repos-server (Oracle): accept and pass through pristine-tar metadata.
  * tag2upload-oracled: Restart requests: restart right away.  [Sean Whitton]
  * Testing and refactoring to support planned pristine-tar work.

  i18n:
  * nl: Update message translations.
    Closes: #1135223.  [Frans Spiesschaert]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 03 May 2026 16:13:39 +0100

dgit (15.7) unstable; urgency=medium

  tag2upload development:
  * design doc: Make critical tag items solely the Oracle's responsibility.
  * tag2upload-obtain-origs: Recognise pristine_tar setting and fail.

  * CI: disable broken uscan test.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 25 Apr 2026 10:58:56 +0100

dgit (15.6) unstable; urgency=medium

  * tag2upload: Use dpkg-source from testing, to enable uploads
    of "3.0 (quilt)" packages with revisions.  Closes: #1133764.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 19 Apr 2026 17:22:10 +0100

dgit (15.5) unstable; urgency=medium

  dgit:
  * New --batch option, for better behaviours in noninteractive contexts.
    Currently: passes batch ssh optios to dgit rpush's ssh;
    enables a default retry schedule; and, suppresses advice
    to the user about how best to make another upload attempt retrying.
  * New --retry-scheddule option, for retrying some network operations.
    Currently, just retries dput.

  tag2upload:
  * Pass --batch to builder's dgit.  Closes: #1129363.
  * Have git (run as part of tag2upload) invoke ssh with batch options.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 11 Apr 2026 20:28:48 +0100

dgit (15.4) unstable; urgency=medium

  i18n:
  * nl: Update message translations.
    Closes: #1132540.  [Frans Spiesschaert]
  * pt: Update message and manpage translations.
    Closes: #1132732, #1132733.   [Américo Monteiro]

  tag2upload image script:
  * Try to elminiate some warnings from gnupg in tag2upload upload reports.
    Fixes part of #1131609.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 05 Apr 2026 00:51:20 +0100

dgit (15.3) unstable; urgency=medium

  Bugfixe:
  * dgit: Handle experimental specially.  Closes: #1129641.

  Minor improvements:
  * dgit: Correct tense of a message
  * dgit: dgit -D fetch no longer outputs listing of historical tags.

  tag2upload development:
  * Install ca-certificates as well as curl in t2u-integration test (fix CI).
  * Deposit copies of t2u upload signing key from Oracle and Builder image
    to Manager.  Part of #1130653.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 29 Mar 2026 16:20:43 +0100

dgit (15.2) unstable; urgency=medium

  * Disable many slow tests on riscv64 to fix problems in ci.debian.net.
  * dgit: Fix --untaint-history alias.
    Closes: #1131501.  [Report from Simon Josefsson]
  * Skip version 15.1 to avoid 15.1~bpo, which would look < 15.1~exp1.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 22 Mar 2026 18:01:49 +0000

dgit (15.0) unstable; urgency=medium

  * dgit behavioural change: dgit push is now dgit push-source,
    not dgit push-built.  Likewise dgit rpush.  See NEWS.Debian.

  Bugfixes relating to handling of upstream signatures on origs:
  * dgit: When transferring origs, do transfer signatures too.
  * dgit: Fix whole-archive (cross-suite) orig search when signatures exist.
    [Report from Simon Josefsson]  Closes: #1130113.
  * git-debrebase: Ignore orig signatures in dgit view import precheck.
  * Add .sig to list of signature extensions.

  tag2upload:
  * tag2upload-builder-rebuild: Set git user and email config
    to fix metadata of synthesised commits.  Closes: #1129532.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 15 Mar 2026 21:25:57 +0000

dgit (14.11) unstable; urgency=medium

  tag2upload improvements:
  * git-debpush: Support --deliberately in git-debpush.  Closes: #1127470.
  * git-debpush, dgit: Provide --untaint-history convenience alias for
    --deliberately-include-questionable-history.  As per #1127470.
  * Generate our own Message-IDs on the Oracle, and convey them to the
    Manager via o2m protocol 9.  Closes: #1127618.
  [Reviews and fixes from Sean Whitton]

  Bugfixes:
  * tag2upload: Don't sometimes send emails with wrong status in Subject.
  * tag2upload: Do not include inapplicable retry advice in email reports.
  * dgit/tag2upload overwrite checks: Do not refer inaccurately to the archive.
  * dgit/tag2upload: Avoid crashing on some fatal errors due eg to
    unfinalised changelogs.  Closes: #1126152.
  * dgit rpush: Do print applicable retry advice on early failures.

  Documentation:
  * Completely overhaul docs of --deliberately, and error messages.
    New section in dgit(7) describing tainted history.
    Closes: #990667, #1127666.  [Reports from Osamu Aoki & Simon Josefsson]
  * dgit(1): Expand xrefs.  Closes: #1128591.  [Report from Simon Josefsson]
  * git-debrebase(1): Document --noop-ok for scrap, make-patches.
    Promptted by #1129577.  [Report from Charlemagne Lasse]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 08 Mar 2026 17:06:24 +0000

dgit (14.10) unstable; urgency=medium

  dgit (including tag2upload server-side):
  * Improve error messages for apparently-unintentional ovewrite
    (ie, archive version missing from changelog).  Closes: #1128295.

  Packaging:
  * Depend on git, not the very-obsolete git-core virtual package.

  tag2upload development:
  * t2u o2m protocol: Define version 9, conveying the message-id.
  * t2u o2m protocol: Talk about "final" email reports

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 01 Mar 2026 15:18:49 +0000

dgit (14.9) unstable; urgency=medium

  tag2upload server-side bugfix:
  * Honour --deliberately options in tag2upload tags.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 22 Feb 2026 13:57:47 +0000

dgit (14.8) unstable; urgency=medium

  dgit:
  * dgit gbp-build: Honour new *.quilt-mode-gbp config option.
    [Report from Theodore Tso]  Closes: #1127809.
  * Provide bespoke usage error for --deliberately without -<something>.

  Documentation
  * dgit(1): Fix manpage promise: we test on bullseye, not buster.

  dgit-repos and tag2upload server-side UX changes (yet to be deployed):
  * Provide better advice when pushing NEW/REJECT-tainted history.
  * When suggesting --deliberately, suggest --deliberately-<something>,
    and give specific reference to dgit(1) not just "documentation".
  * Fix stderr output when forcing a taint.  Closes: #1127378.
  * Don't try to do anything with repos/_empty.  Closes: #1127826.
  * Remove the comma (after status) from all the email subjects.

  Testing:
  * Much new integration testing of various tag2upload error cases.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 15 Feb 2026 12:50:44 +0000

dgit (14.7) unstable; urgency=medium

  tag2upload development:
  * tag2upload-oracled: Provide complete error message when reboot lock held.

  Fixes for gnupg/sqv incompatibilities in tests:
  * Update key self-cert hashes to fix test failure complaining about SHA1.
    Closes: #1126793.  [Report and suggestion from Simon McVittie]
  * Migrate to new gnupg secret key format for in-tree keys.
  * Revert attempted use of SEQUOIA_CRYPTO_POLICY (which is broken).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 02 Feb 2026 20:16:08 +0000

dgit (14.6) unstable; urgency=medium

  * tests: Set SEQUOIA_CRYPTO_POLICY to work around apt's
    date-based SHA1 deprecation, which trips on our test keys.
    [Report from Simon McVittie]  Mitigates #1126793.
  * tests: t2u-gbp: Avoid spawning an editor if run interactively.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 01 Feb 2026 16:02:24 +0000

dgit (14.5) unstable; urgency=medium

  Manpage fixes (fixes warnings from new groff [Colin Watson]:
  * dgit(1): Remove duplicate `.TP` request.
  * tests: manpages-format: Ignore font name warnings

  tag2upload development:
  * Fixes relating to email reports:
    - Do not CC the tag signer if we're not emailing the tagger.
    - On failed last attempt, report "failed" in X-headers and Subject.
    - Fix a fd concurrency bug which can garble gpg output in email reports.
    - Wrap recipient headers.
    - oracle not longer wrongly says "email reported" on retriable failure
      (this bug would prevent the ultimate report to the user).
    - Restore the inclusion of the exit status from tag2upload-obtain-origs.
  * Fix and improve reporting of software versions by oracled
    [Sean Whitton and Ian Jackson]
  * oracle-to-manager protocol clarifications/corrections.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 26 Jan 2026 21:06:14 +0000

dgit (14.4) unstable; urgency=medium

  tag2upload development [Sean Whitton]
  * oracled: Speak manager protocol version 8, reporting software versions.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 19 Jan 2026 22:07:51 +0000

dgit (14.3) unstable; urgency=medium

  tag2upload development [Ian Jackson]:
  * Make some failures retriable:
    - when 'dgit download-unfetched-origs' fails to query the archive
      (e.g. a connection timeout)
    - when regenerating the orig fails but the correct one might become
      available via the archive later
    - when fetching from salsa fails with a HTTP 500 series error
      Closes: #1112106.
  * Use actual job status in email Subject.
    Main change is that users will see "irrecoverable" instead of "failed".
  * Define o2m protocol version 8 to convey software versions.
  * Include the last attempt message on in the summary, not the transcript.
  * tag2upload-obtain-origs: Fix an argument checking bug.
  * When running tag2upload-* scripts fails, put script name in the report.
  * Supporting internal changes, including breaking out a new script
    'tag2upload-fetch-inputs'.

  tag2upload-oracled:
  * New --version option.

  Documentation:
  * dgit-maint-{debrebase,merge,gbp,native}(7):
    Say to upload with git-debpush.
  * dgit-maint-bpo(7), dgit-sponsorship(7), dgit-nmu-simple(7):
    Mention git-debpush where appropriate.
  * dgit-maint-{debrebase,merge}(7): Always push to salsa.
  * dgit-maint-debrebase(7): Recommend 'git debrebase quick',
    not 'git debrebase', right before uploading.  Closes: #1111233.
  * dgit(1): Fix a formatting error.  [Ian Jackson]

  i18n [Américo Monteiro]:
  * pt: New translation for dgit's messages.  Closes: #1125493.
  * pt: Updated dgit(1), dgit-downstream-dsc(7).  Closes: #1125499.

  Test suite [Ian Jackson]:
  * t2u-email: Add bounds so that we detect text added to beginning and end.
  * t2u: When grepping e-mails, grep only the body parts.
  * http-static-server: Yield better HTTP status codes.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 17 Jan 2026 14:58:07 +0000

dgit (14.2) unstable; urgency=medium

  tag2upload:
  * Send emails to the uploading user in all failure paths, using the
    address in the tag's tagger line (from the Manaager) if necessary,
    and by telling the Manager `email unreported` when that's not possible.
  * If we a job arrives when a host is about to reboot, call it a retriable
    failure.  (Not wholly effective; see also #1125239.)  [Sean Whitton]

  tag2upload development:
  * o2m protocol version 7, convey the user's email address,
  * Move retry schedule docs to tag2upload-service-manager.git.
  * Rename "noreply" config to "from".  (We're using a deliverable address.)
  * Many improvements to oracled's logging.  [Sean Whitton, Ian Jackson]
  * tests: t2u-integration: Provide configuration used by t2usm email feature.
  * Many supporting (and testing) changes.  [Sean Whitton, Ian Jackson]

  Testing:
  * Unset http_proxy (to make tests more self-contained).
  * When polling for perhaps a long time, start much faster.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 11 Jan 2026 23:40:11 +0000

dgit (14.1) unstable; urgency=medium

  * tests: gitattributes: Add git-deborig dependencies to fix autopkgtests.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 01 Jan 2026 19:11:29 +0000

dgit (14.0) unstable; urgency=medium

  Possibly-breaking changes to dgit build subcommands:
  * dgit sbuild, pbuilder, cowbuilder: Run sbuild, pbuilder or cowbuilder
    in the original invocation directory, rather than the build-products-dir.
    Pass the the bpd via the appropriate command line option.
    [Report from Jochen Sprickerhof]  Closes: #1124014.
  * dgit pbuilder, cowbuilder: Pass -us -uc to dpkg-buildpacckage.

  Possibly-incompatible change in gitattributes handling:
  * Suprress all transforming gitattributes.
    - dgit suppresses export-* (in dgit clone, setup-new-tree, etc.)
    - git-deborig and tag2upload suppress non-export-* gitattributes.
    Generated tarballs/.origs will change, for affected git trees.
    [Report from Simon Josefsson]  Closes: #1111548.

  Synthetic commits' metadata change:
  * Use a fixed name & email address for the committer of dsc imports,
    rather than (ab)using the author details (from the package changelog).
    (dgit 14.x's imports' git history will not match earlier dgit's.)
    [Report from Cyril Brulebois via Philip Hands]  Closes: #1124226.

  i18n:
  * pt: Updated git-debpush(1), new translation dgit(1).
    [Américo Monteiro]  Closes: #1124136.

  Bugfixes:
  * git-deborig now never leaves behind an unwanted change to the user's
    .git/info/attributes.  Instead, on certain error paths, it can now leave
    the working tree's .gitattributes file dirtied.  Improves #1124383.
  * Use a .invalid domain (rather than example.com) for the non-user-facing
    internal commits in the reflog-based quilt fixup cache.

  tag2upload development [Sean Whitton]:
  * tag2upload-oracled: Speak manager protocol version 6.  
  * tag2upload-oracled: Improved logging.

  Supporting work:
  * Improvements to ProtoConn.  [Sean Whitton]
  * Overhaul of tag2upload-oracled/dgit-repos-server API.  [Sean Whitton]
  * Improvements to test suite.  [Ian Jackosn & Sean Whitton]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 31 Dec 2025 15:24:52 +0000

dgit (13.20) unstable; urgency=medium
  
  tag2upload development:
  * t2u o2m protocol: Restore the last attempt MESSAGE.
    [Mistake spotted by by Sean Whitton]

  Fixes to cope with new libdpkg-perl (Closes: #1123583):
  * git-deborig: Pass no_check as well as nocheck to spawn.
  * Dgit.pm: Provide and use reimplementation of is_native.
  * git-deborig: Suppress a new warning about is_native.

  i18n:
  * nl: Update Dutch message
    [Frans Spiesschaert]  Closes: #1120337.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 23 Dec 2025 19:17:30 +0000

dgit (13.19) unstable; urgency=medium

  tag2upload development:
  * t2u oracled: Logging improvements.  [Sean Whitton]
  * t2u oracle-to-manager protocol document: introduce protocol 6,
    with provision for retries, and reporting of whether email sent.
    Not yet implemented.  See #1112106; tag2upload-service-manager#37.
    [Ian Jackson with assistance from Sean Whitton]

  Testing:
  * stunt changelog parser: cope with 'filename' in %options in innards.
    [Report from Guillem Jover]  Closes: #1123654.
  * New dev helper utility tests/install-deps-remove-debs.
  * Fix a protocol violation (race) by fake t2usm.
  * t2u-integration: don't kill the whole process group (race fix).
  * CI: Test against Debian testing.  See salsa-ci-team/pipeline#532.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 19 Dec 2025 14:43:29 +0000

dgit (13.18) unstable; urgency=medium

  git-debpush:
  * Disable interactively overriding some check failures.
    For check failures which indicate the upload will almost certainly fail,
    just exit.  [Prompted by feedback from Stuart Prescott]
  * git-debpush(1): Document some checks for which docs were missing.
  * git-debpush(1): One minor presentational tweak.

  tag2upload service:
  * Restart tag2upload-oracled on dgit-infrastructure.deb upgrades.
    Closes: #1117735.
  * Take a lock of /var/run/reboot-lock on the Oracle and Builder.
    Closes: #1118197.
  * Use our new custom tmpfs as TMPDIR on the Builder.
    Closes: #1118190.
  * tag2upload-builder-rebuild: Take the Debian release from the crontab.
  * Upgrade the Builder's Podman container bookworm->trixie.

  i18n:
  * pt: Add dgit(7); add git-debpush(1); update others.
    Closes: #1118952.  [Américo Monteiro]

  Test suite:
  * Rebuild dgit-infrastructure.deb before commencing Salsa CI.
    This is necessary because it can now gain a versioned dependency on
    init-system-helpers.
  * Delete t2u-integration-bookworm Salsa CI job.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 12 Dec 2025 15:49:26 +0000

dgit (13.17) unstable; urgency=medium

  git-debrebase:
  * Merge resolution: tolerate nested vanilla merges, and maybe
    deal bettter with other unusual situations.
    Closes: #1116600.  [Report from David Bremner]

  dgit:
  * Try downloading missing artefacts from incoming.d.o/debian-buildd.
    Reduces apparent archive skew, eg with "dgit fetch".
    In tag2upload, will better handle quick re-upload after a new upstream.
    Closes: #1111728.  [Suggested by Colin Watson]
  * download-unfetched-origs: Check that bpd exists, failng early if not.
  * Report filename, not url, in "downloading" message, unless all are 404.
  * On an archive file mismatch, print lengths too, not just hashes.

  git-debpush [Sean Whitton]:
  * Minor improvements to some mesages.

  Documentation:
  * tag2upload: Add some xrefs in TAG2UPLOAD-DESIGN.txt.
  * Retrospectively add two missed bug Closes to entries for 12.12 and 12.1.

  i18n:
  * nl: Updated messages and dgit-user(7).
    Closes: #1115336, #1115338.  [Frans Spiesschaert]
  * pt: Added git-debrebase(5); updated tag2upload(5).
    Closes: #1118296.  [Américo Monteiro]

  Supporting work:
  * Much refactoring of download handlng.
  * Better testing of download-unfetched-origs.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 24 Oct 2025 19:06:20 +0100

dgit (13.16) unstable; urgency=medium

  git-debrebase bugfixes [Ian Jackson]:
  * Merge resolution: Fix erroneous use of real git tree as
    if it were a private working area.  Closes: #1116933.
  * Merge resolution: Fix conflation of different temporary directories.
  * Clean out all of the temporary playground area on every invocation.
  * Nail down the date for constructing git commits, to avoid
    stochastic failures (especially during vanilla merge resolution).

  dgit bugfixes [Ian Jackson]:
  * dgit: Print progress when downloading files mentioned in .dscs,
    eg in download-unfetched-origs.  Closes: #1111355.

  Packaging:
  * Switch git-debpush.deb dependencies from gnupg to gpg, gpg-agent.
    Allows use with implementations other than gnupg.
    Closes: #1116659.  [Paride Legovini, Sean Whitton]

  New feature:
  * git-debrebase: Provide git-debrebase examine COMMITISH.  [Ian Jackson]

  Documentation:
  * i18n: More European Portuguese manpages translations.
    Closes: #1114805.  [Américo Monteiro]
  * git-debpush(1): Reword --quilt=linear description,
    to disambiguate it somewhat.
  * dgit(1): Reflect that curl(1) is not in fact used by dgit, nowadays.
    [Ian Jackson]

  Cleanups and supporting changes [Ian Jackson]:
  * dgit: Abolish the obsolete sshpsql archive access method.
  * dgit innards: Deconfuse/disambiguate "archive_query" functions.
  * Other minor tidying in git-debrebase and dgit.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 07 Oct 2025 17:43:34 +0100

dgit (13.15) unstable; urgency=high

  tag2upload service:
  * (Try to) avoid crashing when printing repro instructions.
    Closes: #1115319.  [Report from Simon Josefsson]

  Documentation:
  * Even more man7 European Portuguese translations.
    Closes: #1112134.  [Américo Monteiro]
  * Fix typos in dgit-maint-gbp(7).  [Teemu Hukkanen]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 15 Sep 2025 21:56:29 +0100

dgit (13.14) unstable; urgency=medium

  tag2upload service:
  * tag2upload: On source package discrepancies, print a diffstat
    and instructions for a local repro.  Closes: #1111357.

  git-debpush:
  * Check that the repo is accessible via http.  Closes: #1111319.
  * Support --quilt=single.
  * Print the name of the tag we make.  Closes: #1112040.  [Sean Whitton]

  dgit:
  * Improved output on quilt and dsc discrepancy errors:
    show and explain a diffstat, and use the same logic in each case.

  Documentation:
  * More man7 European Portuguese translations.
    Closes: #1112134.  [Américo Monteiro]
  * git-debpush(1): Mention that git-debrebase needs --quilt=linear.
  * git-debpush: Tidy quilt mode information in manpage and usage message.
    [Ian Jackson and Sean Whitton]
  * tag2upload(5): Specify how pristine-tar metadata item will appear.
    [Andrea Pappacoda and Ian Jackson]

  Internal and supporting changes:
  * CI: Fix gitlab-ci-check-sob to work in contributors' forks.
  * tests: t2u-integration: Provide a user_id in json, for new t2usm.
  * using-these: Put absolute directory on PATH; fixes for programs that cd.
  * git-debpush: Code comment fixes.  [Sean Whitton]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 05 Sep 2025 10:16:53 +0100

dgit (13.13) unstable; urgency=medium

  tag2upload:
  * git-debpush: Don't become confused and warn about nonexistent pristine-tar
    metadata.  Closes: #1111504.  [Sean Whitton; report from Birger Schacht]
  * git-debpush: Make submodule check precise.
    Closes: #1111194.  [Report from Simon McVittie]
  * dgit, t2u: --quilt=gbp no longer minds patches editing .gitignore
    Closes: #1111696.  [Report from Simon Josefsson]
  * dgit: Reject --quilt=baredebian+barball in tag2upload builder mode.

  i18n [Américo Monteiro]:
  * dgit-user(7) manpage: Provide Portuguese translation.
  * git-deborig(1): Update Portuguese translation.  Closes: #1111527.

  Documentation:
  * git-debpush(1): Fix link markup.  [Sean Whitton]
  * git-debpush(1): Add references to other tag2upload docs.  [Sean Whitton]
  * dgit(7): Give advice for if upstream source relies on gitattributes.
  * dgit-nmu-simple(7): Document this as the best way to do a git-based NMU.
  * git-debpush(1): Document --quilt=unapplied, not just --quilt=gbp.
  * changelog: 13.12: Add missing Closes for #1108181.  [Sean Whitton]

  dgit bugfix:
  * dgit: baredebian: Fix diff instruction if upstream files discrepant.

  Packaging improvements:
  * git-deborig: Replace several Perl module dependencies
    with inline code and/or use of Dgit::Core.  [Sean Whitton]

  Testing:
  * git-deborig: New tests.  [Sean Whitton]
  * git-debpush: Test that we push the upstream tag.  Re #1111305.
  * CI: Disable some more useless jobs.
  * CI: add t2u-integration-trixie job.

  Other changes:
  * git-deborig: Improve an error message.  [Sean Whitton]
  * Internal tidying and refactoring.  [Sean Whitton and Ian Jackson]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 24 Aug 2025 11:43:28 +0100

dgit (13.12) unstable; urgency=medium

  dgit changes [Ian Jackson]:
  * build-source now checks for git vs dsc discrepancies.
    Other build subcommands are unchanged.  Closes: #1110907.
    - New dgit-distro.DISTRO.build-source-check-correspondence option.
      You can use this to restore build-source's old behaviour of
      deferring discrepency checking to the push phase.
  * Report git vs dsc discrepancies with exit status 6.

  git-debpush fixes:
  * Hide output from git-tag(1) run in the playtree.
  * Move checks depending on quilt mode autodetection later.
    Closes: #1111109.
  * Pass --no-pager when failing a check with a git diff.
    [Ian Jackson]

  New program:
  * git-deborig, moved from 'devscripts' package.  Closes: #1108181.
    See also #1105759.
  * Declare that bin:git-debpush replaces bin:devscripts <<2.25.18.

  tag2upload service:
  * tag2upload-builder-crontab: Move the job from 03:00 to 03:55.
  * tag2upload-builder-rebuild: Revert to installing from testing.
  * tag2upload-builder-rebuild: Rebuild only once (!).
    [Ian Jackson]

  Documentation:
  * git-debpush(1): New "Mistakes" section.
  * git-debpush: Additional design notes.
  * i18n: Import de, fr, pt translations for git-deborig(1).
    Closes: #1110822.

  Internationalisation [Ian Jackson]:
  * 'make i18n-commit' adds new potfiles and cleans up old pofiles.
  * Rename old po4a/list-documents to po4a/generate-po4a.cfg.
    - Fix for when there are multiple languages (!).
  * New po4a/list-documents script.
  * Test that we have all the potfiles we expect.
  * po/README: Give more translation priority advice.
  * po/README: Other updates.
  * Makefile: Replace the various pod2man targets with pattern rules.
  * Fix titles of translated manpages.

  Test suite:
  * t2u-debpush-gbp: Make an edit to debian/, not the upstream.
    [Ian Jackson]
  * t2u-debpush-gbp: Test git-debpush's 'upstream-nonidentical' check.
    [Ian Jackson]
  * Use in-tree git-deborig.
  * Disable missing-breaks Salsa CI job.

  Miscellaneous/internal:
  * Give the git-debpush package a private /usr/share/dgit/gdp/perl5.
    - Move git-debpush's copy of git-playtree-setup there.
  * New Debian::Dgit::Core module installed into all binary packages.
  * git-debpush: Rework some code sectioning.
  * Don't show the version of Perl in manpage footers.  [Ian Jackson]
  * Some copyright notice updates.
  * Adjustments for trunk branch name change.  [Ian Jackson]

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 15 Aug 2025 10:05:44 +0100

dgit (13.11) unstable; urgency=medium

  * No change upload, targeting mainline to unstable.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 10 Aug 2025 20:18:45 +0100

dgit (13.11+exp1) experimental; urgency=medium

  git-debpush UX improvements:
  * Always print a message before fetching from salsa.
    Closes: #1110402.  [Sean Whitton]
  * Detect debian/source/local-options, as a failed check.
    This avoids later failures.  Closes: #1110339.  [Sean Whitton]
  * Detect redundant --quilt mode option, as a failed check.
    Helps useers avoid dangerous habits.  Closes: #1108378.  [Sean Whitton]
  * Detect possible intent to use pristine-tar even if pristine-tar
    is not installed.  [Andrea Pappacoda]

  tag2upload service:
  * If origs cannot be obtained from the archive (eg due to mirror delays),
    try to regenerate them.  Closes: #1109130.  (Deployment TBC.)

  Documentation:
  * Workflow manpages: Replace bookworm with trixie.  [Sean Whitton]
  * Workflow manpages: Suggest sbuild -d, not sbuild -c.  [Sean Whitton]
  * tag2upload(5): Specify ! for service-critical extensions.

  Minor bugfixes:
  * git-debpush: Avoid ignoring a failure of git-cat-file.  [Sean Whitton]
  * Add missing newline to overridden --force fail message.

  dgit download-unfetched-origs subcommand (changes to support tag2upload):
  * Look in the source tree's current suite, specifically.
  * New --write-sha256sums subcommand option.
  * Don't download files already present in the build-products-dir.
  * Save downloaded files to .tmp names until file checksums verified.
  * Report unobtainable origs with special exit status 3.

  Supporting and internal changes:
  * Cleanups and defensiveness in tag2upload-oracled.  [Sean Whitton]
  * Code cleanups, and refactoring, in git-debpush.  [Sean Whitton]
  * Much logic moved from tag2upload-obtain-origs into dgit.

  Tests:
  * Refactoring and additions for testing the new functionality.
  * restore checking of error messages in tag2upload emails.
  * t2u-integration: Include the event_name field in webhook.
    (Compatibility with tag2upload-service-manager changes.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 10 Aug 2025 19:58:53 +0100

dgit (13.10) experimental; urgency=medium

  git-debpush user experience improvements:
  * Print some status messages while processing.
  * Better error messages when git-deborig tag search fails.
  * New --help, -h options.  Closes: #1109473.

  tag2upload infrastructure:
  * Switch to using new tag2upload-obtain-origs script.
    Closes: #1108658.  [Ian Jackson]
  * tag2upload Manager protocol: Introduce some protocol state names.
    [Ian Jackson]
  * tag2upload-oracled: Speak Manager protocol version 5.
  * tag2upload-builder-rebuild: Request restarting workers.

  git-debpush miscellaneous:
  * Expand and update statement of design principles.
  * Delete a completed TODO.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 28 Jul 2025 13:53:45 +0100

dgit (13.9) experimental; urgency=medium

  tag2upload infrastructure:
  * Improve and shorten command lines appearing in report emails.
  * Check upstream tag/commit correspondence even when using existing origs.
  * Minor performance improvement for native packages (skip pre-fetch).

  Internal changes:
  * Testing improvements for tag2upload.
  * changelog: Start 13.9
  * Introduce new tag2upload-obtain-origs script.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 19 Jul 2025 11:51:39 +0100

dgit (13.8) experimental; urgency=medium

  git-debpush user experience improvements:
  * Check for and handle an existing tag for this version.
  * Try to check our branch against the remote target branch,
    to detect releasing from behind mainline, and avoid push failures.
    Closes: #1107921.

  Internal changes:
  * dgit: Provide abbreviated --t2u-* options, to support log improvements.
  * git-debpush: Improve comment about remote branch.  [Sean Whitton]
  * git-debpush: Coding style cleanups.
  * dir-locals.el: Set fill-column to 78 for all languages.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 18 Jul 2025 17:36:28 +0100

dgit (13.7) experimental; urgency=medium

  * Demo upload for talk.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 15 Jul 2025 08:33:32 +0100

dgit (13.6) experimental; urgency=medium

  * Demo upload for talk rehearsal.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 14 Jul 2025 20:26:58 +0100

dgit (13.5) experimental; urgency=medium

  git-debpush user experience improvements:
  * Check for tag already existing at the remote.  Part of #1107921.
  * Improve error message for tag already existing locally.
  * Check for uncommitted changes in working tree.
    Closes: #1108088.  [Sean Whitton]

  tag2upload service:
  * Properly RFC2047-escape non-ASCII names.  Closes: #1108613.
  * Hide virt runes in a per-invocation ssh wrapper  Closes: #1107151.
  * Print oracle and builder dgit versions in transcript.  Closes: #1108242.
  * d-r-s t2u: Add missing -oBatchMode=yes option to ssh invocation.

  CI and administrivia:
  * CI: Check for missing Signed-off-by.
  * git-debpush: Add missing copyright notice.  [Sean Whitton]
  * Add missing Closes for #1108180 to changelog entry for 12.125.
  * CI: Drop compatibility tests for buster, which is gone from the archive.

  Suppporting changes:
  * git-debpush: Figure out the previous maintainer upload version.
  * dgit: Honour DGIT_VERSION in dgit --version and use it in ./using-these.
  * git-debpush: Reorganisation and tidying.  [Ian Jackson and Sean Whitton]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 14 Jul 2025 09:45:16 +0100

dgit (13.4) experimental; urgency=medium

  Documentation:
  * t2u o2m: Describe version 5, with 'restart' message.  [Sean Whitton]
  * t2u FAQ: Clarify that debian/-only repos still need
    upstream source in git.  [Christoph Berg]
  * t2u FAQ: Remove much obsolete material.

  Tests:
  * t2u: Test "tag changed between fetches" path.
  * CI: Check for blocking todos (three or more X's).

  Internals:
  * Avoid blocking-todo markers in a few places in docs and comments.
  * dgit-repos-server: Fix a comment about indistrodir.
  * tests: debpolicy-taintrm: Downgrade a TODO.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 22 Jun 2025 19:03:47 +0100

dgit (12.15) unstable; urgency=medium

  git-debpush bugfixes:
  * Fix package dependencies.  Closes: #1108180.
  * Do not pointlessly print "pristine-tar is /usr/bin/pristine-tar".
  * Some shell quoting fixes.

  Shell scripts:
  * Use shopt -s inherit_errexit everywhere to work around #514862.

  Testing:
  * New more-minimal standalone test cases for git-debpush.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 22 Jun 2025 17:53:17 +0100

dgit (13.3) experimental; urgency=medium

  git-debpush behavioural improvements:
  * Read a whole line when prompting.  Closes: #1107897.
  * Drop changed-suite check.  Closes: #1107552.
  * Exit immediately if overriding a check denied by user.

  git-debpush fix:
  * Fix parsing --batch command line option.

  Documentation [Ian Jackson]:
  * tag2upload(5): New "SEMANTICS" section.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 18 Jun 2025 13:55:28 +0100

dgit (13.2) experimental; urgency=medium

  * git-debpush: Rename --no-prompt to --batch.   [Sean Whitton]

  Administrivia:
  * d/source/options: Declare source format to be native.
    (Should enable uploading with git-debpush.)   [Sean Whitton]
  * CI: Add trixie to salsa CI
  * Include fixes from dgit 12.14 (as shown below).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 16 Jun 2025 18:49:49 +0100

dgit (12.14) unstable; urgency=medium

  * tests: t2u: Add missing dependency on pristine-tar; fixes CI.
  * git-debpush: Suppress some spurious and confusing messages.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 16 Jun 2025 17:58:19 +0100

dgit (13.1) experimental; urgency=medium

  git-debpush behavioural improvements [Sean Whitton]:
  * Detect apparent intent to use pristine-tar (which is not supported).
    Closes: #1105862.  [Reports from Simon Josefsson, Anton Gladky]
  * Detect presence of git submodules, and fail early.
    Closes: #1107226.  [Report from Andrea Pappacoda]  See also #726953.
  * When checks fail, prompt interactively, asking whether to proceed.
    Closes: #1105815, #1107550.
  * Rename hazardous --quilt=auto, to --quilt=try-linear.
    [Prompted by report from Anton Gladky]

  git-debpush(1) improvements [Sean Whitton]:
  * Document that we never do a git force push.
    Closes: #1105756.  [Report from Simon Josefsson]
  * --quilt=gbp: Mention quilt(1) explicitly.  [Report from Anton Gladky]
  * Fix erroneous dedent location for end of list of options.

  tag2upload infrastructure:
  * t2u-b-rebuild: Improve logging and error handling.
  * tag2upload-oracled: Predeclare some function prototypes.
    Closes: #1105878.  [Sean Whitton]

  Documentation:
  * Update to non-ancient distribution names in many docs.  [Marc Haber]
  * tag2upload(t5); Fix and clarify semantics of unknown tags,
    multiplicity, ordering, and syntax of keyword=value.
    Closes: #1106078.  [Report from Matthias Urlichs]
  * i18n: Updated message translation for nl.
    Closes: #1106481.  [Frans Spiesschaert]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 13 Jun 2025 15:07:04 +0100

dgit (12.13) unstable; urgency=medium

  (NB: this changelog entry was cross-ported from 12.x (trixie), so it
  includes duplicated information for those changes which were done
  first in 13.x (experimental) and then backported to 12.x (trixie).
  All these were in 13.1, as implied by the placement of this entry.)

  git-debpush behavioural change:
  * Detect apparent intent to use pristine-tar (which is not supported).
    Otherwise we could upload source packages (to the ftp archive) which,
    while correct, were not what the user expected.  Closes: #1105862.
    [Sean Whitton; reports from Simon Josefsson, Anton Gladky]

  Documentation:
  * git-debpush(1): Fix erroneous dedent location for
    end of list of options.  [Sean Whitton]
  * i18n: Updated message translation for nl.
    Closes: #1106481.  [Frans Spiesschaert]

  Administrivia/testing:
  * gitlab CI metadata: Add dgit-test-suite trixie job.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 13 Jun 2025 16:09:04 +0100

dgit (13.0) experimental; urgency=medium

  Documentation:
  * dgit(1): Document exit status.

  New feature:
  * dgit: New operation mode download-unfetched-origs.

  Infrastructure bugfixes:
  * tag2upload: Fetch origs from other suites, too.
    Avoid creating inconsistent sets of orig tarballs.
    [Report from Simon Josefsson]  Closes: #1105766.
  * dgit-repos-server: Fix changing suites while in NEW.

  Supporting changes and tidying up:
  * tag2upload-builder-rebuild: Pull our packages from experimental
    so that we can deploy the bugfixes.  [Sean Whitton]
  * Update paths to Debian keyrings.  [Sean Whitton]
  * Internal improvements and refactorings.
  * tests: Add experimental to suite lists.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 17 May 2025 13:02:53 +0100

dgit (12.12) unstable; urgency=medium

  Bugfixes:
  * git-debrebase: Use add -f for d/p/series in merge resolution
    Closes: #1101958.  [Report from Sean Whitton]
  * Honour debian-nonupload keyring as a DM keyring.  Will enable
    "non-uploading" DDs who have DM permissions to dgit push, and
    use tag2upload.  Closes:1102202.

  Process metadata [Sean Whitton]:
  * dgit-infrastructure package description:
    Say "git depository" as per delegation.
  * Set Maintainer to role address, with humans in Uploaders.
  * Set a GitLab issue template.

  Documentation:
  * git-debrebase(1): fix xref to git-debrebase(5).  [Tony Finch]
    Closes: #1102529.
  * i18n: Updated nl translations for dgit-user(7) and messages.
    Closes: #1103908, #1103910.  [Frans Spiesschaert]

  tag2upload internals:
  * tag2upload-oracled: Add function prototypes.  [Sean Whitton]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 09 May 2025 14:38:16 +0100

dgit (12.11) unstable; urgency=high

  dgit, dgit-repos-server, Dgit.pm [Ian Jackson]:
  * Install countermeasures for 'rm -r' failure (see #1101580).
  * Replace File::Path::rmtree with a subroutine of our own.

  tag2upload-oracled [Ian Jackson]:
  * Fix worker PID tracking, and rigorously avoid sending wild signals.
    Closes: #1101690.
  * Do not ignore SIGCHLD.
  * Quit if the link count of the workercwd becomes zero.

  Test suite:
  * autopkgtest-virt-null-for-test: Avoid 'mkdir -p'.
    Don't recreate the whole test's $tmp directory from here.  [Ian Jackson]
  * autopkgtest-virt-null-for-test: Always set TMPDIR.
    In particular, when autopkgtest is new enough not to require workarounds.
    [Ian Jackson]
  * tag-updates test: Fix $tagname variable.
    Broken for a while, revealed by git 2.49.0 hitting sid.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 31 Mar 2025 11:45:54 +0800

dgit (12.10) unstable; urgency=medium

  dgit:
  * Avoid crash with EEXIST on single-debian-patch and --split-view=always.
    Closes: #1076983.  [Report from Aaron M. Ucko]
  * Better tolerate source trees without debian/rules, eg with debputy.
    Closes: #1092929.  [Niels Thykier; report from Andrea Pappacoda]

  git-debrebase:
  * Unconditionally enable general merge resolution attempts;
    improve relevant documentation, and invite bug reports.
    (Previously this required --experimental-merge-resolution).
  * upstream: Strip epoch in human-facing outputs.  Closes: #1099311.

  workflow manpages:
  * dgit-maint-bpo(7): Replace a lingering --overwrite.  [Sean Whitton]
  * dgit-nmu-simple(7): Be less pessimistic about rebasing.  Closes: #1099519.
  * Disambiguate what we mean by "first ever dgit push".  [Sean Whitton]

  translations [Frans Spiesschaert]:
  * nl: Update translation for messages.  Closes: #1090762.
  * nl: Update translation for dgit-user(7).  Closes: #1090763.

  Infrastructure:
  * Improve handling of stderr output from gpgv.
    (Improves the output for users of dgit push, and tag2upload emails.)

  tag2upload:
  * Builder: Use dgit and gdr from testing.  [Sean Whitton]
  * dgit-repos access control): Expect a separate tag2upload public keyring.
  * Oracle: Pass -u to dput to suppress a spurious warning in email reports.
  * Oracle: Speak oracle-to-manager protocol version 4.
  * Oracle: Report fidelity to Manager (whether we're the production codebase).
  * Oracle/Builder: Always report source package (using info from Manager).
  * Oracle: Improved consistency and informativeness of logging.
  * tests: t2u: Add a test case for a completely unknown signing key.
  
 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 29 Mar 2025 18:04:29 +0000

dgit (12.9) unstable; urgency=medium

  tag2upload development:
  * tag2upload-oracled:
    - Query systemd re whether we are a production or testing instance.
    - New --force-production option.
  * tag2upload-oracled systemd unit:
    - Fix WantedBy= so the user unit starts on reboot.
    - Add additional Documentation= values.
  * TAG2UPLOAD-MANAGER-PROTOCOL.md: Define v3, including worker fidelity.
    [Ian Jackson]

  Test suite:
  * Bypass autopkgtest-virt-null workarounds with newer autopkgtest.
    This should fix our autopkgtest in sid.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 14 Mar 2025 22:32:23 +0800

dgit (12.8) unstable; urgency=medium

  Bugfix to dgit:
  * Fix passing -c options to git.
    While -c options intended to affect dgit work, it was discovered
    that -c options for git itself have been broken since dgit 2.0.
    [Ian Jackson]

  tag2upload development:
  * Improvements to generated e-mail messages:
    - Reorder parts to put the tag last.  [Ian Jackson]
    - Make the log disposition inline.  [Ian Jackson]
    - Add a Reply-To header, use our dgit-owner@ role address in From.
      This fixes our mail not reaching debian-tag2upload@lists.debian.org.
    - Make tag2upload-oracled's --noreply option a full From field value.
      Use this to capitalise "Debian" in "Debian tag2upload service".
    - Replace long line splitting with encoding in quoted-printable.
      DSA's MTA is already doing a conversion to quoted-printable so
      it's cleaner to replace our own long line splitting with this.
      [Ian Jackson]
  * tag2upload-oracled: Don't invoke dgit-repos-server more than once
    in the same working directory, as required by its calling convention.
    This fixes using more than one worker.
  * tag2upload-oracled systemd unit:
    - Work around 'podman exec' failing to set HOME.
    - Work around 'podman exec --user=...' breaking autopkgtest-virt-podman.
      Prefix an invocation of su(1) to switch user, instead.
    - Set IgnoreSIGPIPE=false.
  * Save a copy of all outgoing mail in case of MTA issues.
    [Ian Jackson & Sean Whitton]
  * Have the Oracle use precisely the one available signing key.
    Pass it as a -k option to 'dgit rpush-source'.
    Closes: #932553.  [Ian Jackson]
  * Pass --no-tags to 'git fetch'.  [Ian Jackson]
  * tag2upload-builder-rebuild:
    - Copy in DSA's /etc/ssh/ssh_known_hosts.
    - Copy in Builder's SSH key for dgit-repos access.
    - Copy in public part of Oracle's package signing key.
    - Install dgit and git-debrebase from Debian backports.
    - Install python3-pygit2.
    - Add several abstractions to make it easier to customise our images.
  * tag2upload-oracle-crontab: Add a job to delete old outgoing mail copies.
  * tag2upload-*-crontab: Add comments about how to make changes effective.

  Test suite [Ian Jackson]:
  * t2u-integration: Increase test timeouts.
  * match-check-template: Fix some more output indentation.
  * Move t-dgit lib -> lib-core, simplify tstunt/dgit.
  * Replace generic someuser@somehost with more specific dummy strings.
  * No longer dump sendmail.last.

  Miscellaneous [Ian Jackson]:
  * Consistently use scalars vs arrays for shell-quoted commands and
    not-yet-shell-quoted argument lists, respectively.
    This fixes issues running commands in the tag2upload virt.
  * tag2upload-oracled: Minor improvements to some error handling.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 02 Mar 2025 13:58:10 +0800

dgit (12.7) unstable; urgency=medium

  tag2upload development:
  * Fixes to tag2upload-oracled:
    - Pass -N to nc.openbsd on the Manager.
      This is required for the connection to be properly terminated.
    - Fix protocol violation in the case where '--builder=USER@...'.
    - Actually validate the protocol messages generated by
      'dgit-repos-server --tag2upload5'.
  * dgit-repos-server, tag2upload support:
    - Impose a length limit on various values.  [Ian Jackson]
    - Split long lines in the e-mail.  [Ian Jackson]
  * Other improvements to tag2upload-oracled:
    - Before reporting readiness to the Manager,
      + establish a connection to the Builder;
      + test we can really run commands in the isolation environment; and
      + test we have a usable signing key.
    - New -D option to set the Debian::Dgit debug level.
    - New --worker-restart-timeout option.  [Ian Jackson]
    - Drop old SIGALRM handler, no longer used by test suite.
    - Add [USER@] to --manager and --builder in usage docs.
  * tag2upload-oracled systemd unit:
    - Fill in remaining config values for our current hosts.
    - Instruct autopkgtest-virt-podman not to unshare the netns.
    - Set a value for TimeoutStopSec equal to the processing timeout.
  * Provide tag2upload-builder-rebuild script.
    Previously maintained in dgit-infra-notes-scripts.git.
  * Provide self-installing crontabs for the Oracle and the Builder.

  Test suite:
  * Completely rewrite mocking up tag2upload-service-manager.  [Ian Jackson]
    - tag2upload-oracled now connects to a real socket.
    - Correctly handle the tag2upload-oracled child process, to fix a race.
  * Pass new 'run-manager' subcommand to tag2upload-service-manager.
    [Ian Jackson]
  * gitlab-ci-run-all: Add a per-test-case timeout.   [Ian Jackson]
    This avoids GitLab timing out the whole job and thus losing logs.
  * Always pass new -D option to tag2upload-oracled.
  * Work around autopkgtest-virt-* not exiting (#868576).  [Ian Jackson]
  * autopkgtest-virt-null-for-test: Fix shebang.  [Ian Jackson]
  * Rename template-match-check to match-check-template.  [Ian Jackson]
  * match-check-template: Fix some output indentation.  [Ian Jackson]
  * Print "success." after the log dumps, for reassurance.  [Ian Jackson]

  Documentation:
  * dgit-maint-debrebase(7), dgit-maint-merge(7): Consistently use
    lowercase 'debian' for the salsa.d.o namespace.  [Dr Tobias Quathamer]
  * dgit-maint-gbp(7): In one place, list all three push commands
    instead of just the 'dgit push' alias.  [Dr Tobias Quathamer]
  * dgit-maint-merge(7): Replace a reference to alioth's collab-maint.
    [Dr Tobias Quathamer]
  * TAG2UPLOAD-MANAGER-PROTOCOL.md:
    - Document additional things Oracle should do before saying 'ack'.
      [Ian Jackson]
    - Fix a reference to the worker ID.
  * dgit-user(7): Fix typo comments->commits.  Closes: #1098688.
    [Reported by Ben Harris]

  Miscellaneous:
  * Debian::Dgit::ProtoConn: Call printdebug in expect.
    This ensure we see both halves of the conversation.  [Ian Jackson]
  * get-dm-txt: Take data dir using a positional param, not an env var.
  * d/control: Drop unnecessary Testsuite field.
  * Override 'unusual-interpreter /usr/bin/crontab' Lintian warning.
  * Comment out mismatched file-contains-trailing-whitespace override.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 25 Feb 2025 12:36:05 +0800

dgit (12.6) unstable; urgency=medium

  tag2upload development:
  * Implement & test timing out the work done by dgit-repos-server's
    tag2upload mode, for robustness.  [Ian Jackson]
  * tag2upload-oracled: New --process-timeout option.  [Ian Jackson]
  * tag2upload-oracled systemd unit: Pass --process-timeout.  [Ian Jackson]
  * tag2upload-oracled systemd unit: Fix line continuation syntax.
  * tag2upload-oracled: Tidy up logging and then exiting non-zero.

  Test suite:
  * Use new template-match-check utility to test the content of the
    success e-mail from the tag2upload mode of dgit-repos-server.
    [Ian Jackson]
  * t2u-email test: Also do the mpack MIME check here.  [Ian Jackson]

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 30 Jan 2025 09:13:55 +0000

dgit (12.5) unstable; urgency=medium

  tag2upload development:
  * Rewrite the tag2upload mode of the dgit-repos-server program in
    order to satisfy a number of requirements of the design that the
    old code did not.  [Ian Jackson]
    In particular, we now send much better e-mails.
  * Set the Git-Tag-Tagger and Git-Tag-Info fields.  Closes: #932753.
  * Implement & test CCing the tag signing key's owner.
    - Don't CC them if they're probably also the Git tagger.
    - More strictly validate tag2upload Git tag taggers.
    - New 'preferred-mail-domains' dgit-repos-server configuration.

  * tag2upload-oracled:
    - Validate & log the protocol messages generated by
      'dgit-repos-server --tag2upload5'.
    - Don't expect "ok" in response to "quit".  [Ian Jackson]
      Instead, waitpid the adt virt server.  See #1092808.
    - Improved debug printing.  [Ian Jackson]
    - New --retain-tmp option.  [Ian Jackson]
    - Pass ssh timeout options to builder SSH, too.

  * Pass --ssh:-oBatchMode=yes to dgit in dgit-repos-server t2u mode.
  * Patch autopkgtest-virt-null so as to retain the temp dir.
    [Ian Jackson]
  * Set dgit-repos-server $0 to something else in tag2upload mode.
    [Ian Jackson]

  Test suite [Ian Jackson]:
  * Complete the end-to-end t2u-integration test.
    - Add GitLab CI definition to run it on bookworm as well as sid.
  * Add a test case for a DM attempting to git-debpush a package they
    are not authorized to upload.
  * Fix spuriously removing 'git cat-file tag' trailing newline.
  * Rewrite t2u-ssh-for-t2u-oracled in Perl.
  * Provide and use new general facility for polling in tests.
  * tag2upload-oracled test: Don't kill tag2upload-oracled again.
  * Output improvements when testing 'mini-git-tag-fsck --audit'.
  * Introduce T2U dependencies alias.

  Documentation:
  * dgit-maint-debrebase(7): Improve sample 'git remote add'.
    [Andrea Pappacoda]
  * git-debpush(1): Fix -sn versus -sk.  Closes: #1093216.
    [Reported by Ben Harris]
  * dgit(1), dgit usage message: List push-built|push-source not push.
    This is better because plain push issues a warning, at present.
    Closes: #1092904.  [Ian Jackson, report from Niels Thykier]
  * dgit usage message: Mention rpush-source, and tidy.  [Ian Jackson]

  Miscellaneous:
  * dgit-repos-server: Improved error handling when invoking gpgv.
    [Ian Jackson]
  * Update copyright for dgit, dgit-repos-server & tag2upload-oracled.
  * Fix documentation of --expect-version option.
  * mini-git-tag-fsck: Fix bytestring regexp syntax.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 24 Jan 2025 13:55:00 +0000

dgit (12.4) unstable; urgency=medium

  dgit changes:
  * New --dsc-control-add and --ch-control-add options.
  * With --dry-run, dgit now always writes an edited .changes to a
    temporary file, as it has long done for the edited .dsc.

  tag2upload development:
  * tag2upload-oracled: Speak version 2 of the simple Oracle protocol.
  * dgit-repos-server: Take JOB-ID from tag2upload-oracled.
  * dgit: In --tag2upload-builder-mode, include a _source.buildinfo.
    This is work towards #932802.

  Specifications [Ian Jackson]:
  * Define version 2 of the Manager-to-Oracle protocol.
    The protocol now additionally conveys the job ID.

  Test suite fix:
  * Set "Rules-Requires-Root: binary-targets" in example_1.0.tar.
    Closes: #1092190.

  CI job definitions [Ian Jackson]:
  * dgit-test-suite, t2u-integration: Use a Debian testing image.
    This means that the inputs to our CI are gated by our own tests.
  * t2u-integration: Explicitly install curl.

  Documentation fix [Xiyue Deng]:
  * git-debrebase(5): Fix a few typos of repeated words.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 08 Jan 2025 09:11:11 +0000

dgit (12.3) unstable; urgency=medium

  tag2upload development:
  * dgit: Make --tag2upload-builder-mode imply --dep14tag-reuse=must.
  * tag2upload-oracled.user.service: Use @packages.d.o address in From.
  * Document proposed new calling convention between tag2upload-oracled
    and 'dgit-repos-server --tag2upload4' [Ian Jackson].

  Test suite fix:
  * tag2upload-oracled-systemd-unit: Restore default test dependencies.
    This was breaking this test under autopkgtest.
  
 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 15 Dec 2024 10:38:57 +0800

dgit (12.2) unstable; urgency=medium

  * git-debpush options improvements:
    - Rename patches-applicable check to patches-nonapplicable.
    - Rename suite check to changed-suite.
    - Rename existing -n/--no-push to -t/--tag-only.
    - New -n/--dry-run and --print-tag-text options.
    Closes: #935085.  [Report & suggestions from Ian Jackson]
  
  * git-debpush output improvements:
    - Use uniform line prefix "git-debpush: check failed: ".
      This should make it easier to see which checks failed.
    - Disable whitespace warnings from git-apply.
    Closes: #940590.  [Report & suggestion from Andrej Shadura]
  
  * Test suite fixes:
    - Fix overlapping use of file descriptor 5 by the tests.
      This was breaking all the tag2upload tests under autopkgtest.    
    - t2u-gbp: Replace an unwarranted change of pipefail settings.
    - t2u-gdr: Fix dependencies and environment variable issue.
  
 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 13 Dec 2024 17:06:02 +0800

dgit (12.1) unstable; urgency=high

  Critical bugfix:
  * Once again honour command line options --delayed, -c, -m.
    (-c would sometimes still work, depending on the usage).
    Regressed in 12.0.  Closes:#1089632.  [Report from Sean Whitton]

  New feature for dgit [Xiyue Deng]:
  * New passthrough option, --allow-unrelated-histories.

  Documentation:
  * dgit(1), dgit-user(7): Document dgit's backwards installability.
    Closes: #1081887.

  tag2upload development [Sean Whitton]:
  * Complete mini-git-tag-fsck by implementing its --audit mode.
  * Complete the integration tests for mini-git-tag-fsck.
  * Make the Oracle always invoke mini-git-tag-fsck.
  * Don't call 'git deborig' if we got one from the archive.
  * Fix hardcoded debian/ tag prefix in git-debpush.
  * Test git-debpush's fishing the quilt mode out of history.
  * Some minor code style changes.

  Internal changes & test suite:
  * Tidy up some control of split brain mode.
  * Demonstrate --collab-non-dgit for a native package.
  * Strip junk from a number of tarballs used to set up tests.
  * Fix the gdr-convert-gbp canned setup to call t-select-package
    [Sean Whitton].

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 13 Dec 2024 02:16:53 +0000

dgit (12.0) unstable; urgency=medium

  Possible incompatible changes:
  * dgit push-*: Retain existing DEP-14 tag, even if unsigned, by default.
    New --dep14 options (and config settings) to control the behaviour.
    DEP-14 tag handling and docs overhauled and debugged.
    Closes: #1073787.
  * Command option option handling (--cmd:... etc.):
    Reimplement, with behavioural change bugfix: now you can
    always override configured information from the command line.
    Other misbehaviours and crashes in this area fixed.

  Documentation:
  * dgit-user(7): Use `apt-get build-dep .` in build examples.
  * dgit-sponsorship(7): Mention possible lack of origs.
  * Update Dutch (.nl) translation.  Closes:#1070141  [Frans Spiesschaert]
  * Fix minor docs typos.  [Otto Kekäläinen]

  Other improvements:
  * dgit: Include split-maint-view-tag metadata item in dgit view tag.
  * dgit rpush: Better error handling when child fails.
  * dgit rpush: debug prints: show the files-end message.

  Packaging:
  * debian/control: Bump to debhelper compat level 12.

  Testing - compatibility and bug fixes:
  * Replace use of apt-key with trusted.gpg.d.
    Closes:#1088220.  [Report from Julian Andres Klode]
  * Strip libeatmydata.so out of LD_PRELOAD when using schroot.
    (Fixes in-tree run failures on trixie.)
  * CI: Disable new changelog-empty-entry warning.

  Testing - other improvements:
  * enumerate-tests: Honour TESTSCRIPTS
  * Turn off gbp-buildpackage desktop notifications.
  * CI: Add jobs to test on old releases, back to buster.
  * CI: Better error reporting; use eatmydata; disable two empty jobs.
  * Supporting changes and refactoring.

  tag2upload development:
  * tag2upload-oracled: New program, still in development.
  * Add systemd user unit for tag2upload-oracled.
  * Relax syntax of WORKER-ID in o2m protocol.
  * Break out ProtoConn module for reuse in o2m.
  * New test: integration with tag2upload-service-manager.
  * Run existing tag2upload tests via tag2upload-oracled.
  * Further development of mini-git-tag-fsck.
  * Supporting changes to and refactoring of dgit-repos-server.

  Much of the work described above was done by, or with,
  or reviewed by, Sean Whitton.  Thanks, Sean!

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 29 Nov 2024 01:40:28 +0000

dgit (11.11) unstable; urgency=medium

  [ Ian Jackson ]
  * dgit-repos-server, tag2upload support:
    - Introduce t2uv_* prefix to distinguish trusted parts of t2u flow.
    - New parameter for mail addresses to Cc error messages to.
  * dgit-repos-server, general:
    - New always-accept AUTH-SPEC.
    - Fix & update some debug printing.
    - Some other refactorings.
  * Dgit.pm:
    - git_rev_parse: New \@prefix parameter.

  * dgit: Fix documentation of the rpush protocol.
  * TAG2UPLOAD-MANAGER-PROTOCOL.md: New protocol specification.

  * Test suite:
    - New .gitlab-ci.yml to enable salsa CI.
    - Pass --no-same-owner to tar.
      Fixes running the tests as root.
    - Move some variables out from tests/drs-git-ext to tests/lib.
    - tag2upload: Check for drs dgit success (t-tagupl-succeeded).
    - tests/enumerate-tests: New facility for printing package names.
    - Various renames to replace 'tagupl' abbreviation with 't2u'.
      Not yet complete.
  
  [ Sean Whitton ]
  * dgit:
    - Check that a source-only changes has "Architecture: source".
    - New --expect-suite, --expect-version options for rpush.
      The initiator now checks the values of these options, and that of
      -p/--package, against the parsed changelog, .changes and .dsc sent
      by the responder.  This protects against a misbehaving or
      compromised responder attempting to use the initiator to sign
      .changes and .dsc files for some other package, version or target
      suite.  This is relevant for how the security of the tag2upload
      design relies on the rpush protocol.
    - New --tag2upload-builder-mode, --tag2upload-upstream and
      --tag2upload-upstream-commit options.
      These are used to invoke mini-git-tag-fsck in the right way, and
      --tag2upload-builder-mode may enable other things in the future.
      (As of this release, they are not yet passed by dgit-repos-servers.)
  
  * git-debpush: Add source= & version= to the in-tag metadata (for real
    this time) (Closes: #1069001).
  
  * dgit-repos-server, tag2upload support:
    - Obtain the source package and version from the [dgit ...] metadata.
      (The target suite is still obtained from the first line of the tag
      message; this will change.)
    - Replace invoking 'dgit push-source' with 'dgit rpush-source'.
      This is work towards the new tag2upload three node design.
    - Pass the new --package, --expect-suite and --expect-version.
    - Some other tidying up.
  
  * TAG2UPLOAD-DESIGN.txt: Document SOURCE_VERSION.git.tar.xz.
  * mini-git-tag-fsck: New script to handle SOURCE_VERSION.git.tar.xz.
    Its functionality is only partially implemented as of this release.
  
  * Test suite:
    - Test the new rpush security by mocking up an MITM of the responder
      (tests/ssh-rpush-mitm).
    - Very basic test for --tag2upload-builder-mode.
    - t2u-gbp: Drop an unnecessary, confusing include.

  * Update copyright notices for Ian and me for core files.
  * Add .dir-locals.el.
  * Add some file mode indicators in various places.

  [ Sean Whitton & Ian Jackson ]
  * Add TAG2UPLOAD-FAQ.md.
    With thanks to Russ Allbery for review.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 03 Sep 2024 13:55:01 +0100

dgit (11.10) unstable; urgency=medium

  * Add TAG2UPLOAD-DESIGN.txt [Ian Jackson].
  * git-debpush: Revert changes to in-tag metadata from the last upload.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 22 May 2024 20:42:50 +0100

dgit (11.9) unstable; urgency=medium

  * tag2upload(5):
    - The COMMITID must be an abbreviated hash.
    - Explain why upstream-tag=TAG is required.
    - Add source= & version= to the in-tag metadata.
  * git-debpush:
    - Quote an argument to git-cat-file.
    - Add source= & version= to the in-tag metadata.
  * Replace http->https in GPL file headers.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 21 May 2024 14:08:20 +0100

dgit (11.8) unstable; urgency=medium

  * Fix installation of tag2upload(5).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 14 Apr 2024 20:34:49 +0800

dgit (11.7) unstable; urgency=medium

  [ Ian Jackson ]
  * dgit: Introduce --trust-changelog, as the new name for --overwrite,
    and recommend it everywhere.  As requested in #1050713;
    may help with #913451 #990667 (requests for better docs).
  * dgit: New --collab-non-dgit option.  Closes: #1050713.
    [Apropos informal reports from several people]
  * dgit diff generation: Avoid breaking if user has ui.color=always.
    Closes: #1067222.  [Report from Rafael Laboissière]
  * tag2upload(5): New manpage documenting the tag2upload protocol.
    Closes: #1068231.

  [ Sean Whitton ]
  * Add myself to Uploaders.
  
 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 13 Apr 2024 21:14:43 +0800

dgit (11.6) unstable; urgency=medium

  Improved behaviour:
  * dgit: Delete the playground on success, by default.
    [Report from gregor herrmann]  Closes: #1056103.

  Documentation:
  * dgit(7): Don't falsely assert that *.dgit.d.o is usually `origin`.
  * dgit-user(7): Deprioritise information about jessie.

  Tests:
  * autopkgtests: Install locales-all for i18n-messages test.
  * Stunt httpd: don't respond to HEAD with 404+body.  Closes: #1063341.
  * autopkgtests: Reduce primary log size when running under autopkgtest:
    Save the stderr/stdout to a file which appears (compressed) in
    the artifacts, and is only printed if the test fails.
  * Add comment about benchmarking of the gzip -1 flag on artifacts.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 09 Feb 2024 12:05:39 +0000

dgit (11.5) unstable; urgency=medium

  * dgit: Fix harmless but annoying warning about rebinding $date.
    [Report from Étienne Mollier]  Closes: #1055528.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 10 Nov 2023 13:12:42 +0000

dgit (11.4) unstable; urgency=medium

  dgit dsc import fixes:
  * Do not fail when source package has broken changelog for -1 upload.
    Closes: #1054630.  See also #1051961.  [Report from Peter Green]
  * Pass through the changelog timezone to the generated commit metadata.

  Documentation:
  * dgit-sponsorship(7): Mention git-deborig(1) alongside git-archive(1)
    [Sean Whitton].

  Test suite:
  * Fix i18n-messages test to explictly demand "locales", and set locale.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 30 Oct 2023 02:21:52 +0000

dgit (11.3) unstable; urgency=medium

  * Prevent pushing older versions than is in the archive.
    Closes: #1050711.  [Reports from Helmut Grohne and Phil Hands]
  * Detect tar-ignore in d/s/options and bail early if appropriate.
    Closes: #1050709.  [Report from Helmut Grohne]
  * dgit(1): --overwrite: Add cross reference to --split-view.
    Apropos ##1050713.  [Report from Helmut Grohne]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 03 Sep 2023 00:43:36 +0100

dgit (11.2) unstable; urgency=high

  * Use the old /updates security map only for buster.  Fixes fetching from
    suites ,-security after buster.  [Matthew Vernon]  Closes: #1050179.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 22 Aug 2023 19:25:55 +0100

dgit (11.1) unstable; urgency=medium

  * dgit(1): Adjust tbl formatting to avoid warning.
    [Report and suggestions from Branden Robinson]  Closes: #1041317.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 20 Jul 2023 00:32:36 +0100

dgit (11.0) unstable; urgency=medium

  Bugfix with compatibility implications:
  * Pass --no-source-only-changes to sbuild (when building binaries).
    Fixes operation with SOURCE_ONLY_CHANGES locally overridden.
    (Incompatible with sbuild <0.78; to work around, say
    dgit --sbuild!:--no-source-only-changes.).
    [Report from Sean Whitton]  Closes: #904969.

  Documentation:
  * dgit-maint-{merge,rebase}(7): Cross-reference to gitrevisions(7).
    [Sean Whitton, Ian Jackson]  Closes: #959760.

  Removal:
  * Abolish dgit-badcommit-fixup (the remedial script for #849041).
    If ancient repositories are found which need fixing, install
    dgit.deb 10.7 or earlier (eg from Debian bookworm and earlier).

  Testing;
  * Tests: work around git changes in 2.40 relating to commit verification.
    Skipping tests involving now-uncreatable objects.  Closes: #1033503.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 15 Jun 2023 00:53:22 +0100

# Older entries have been removed from this changelog.
# To read the complete changelog use `apt changelog dgit`.
